/*
 * =====================================================================================
 *       Filename:  sleep.h
 *    Description:  for suspend hibernation stuff
 *        Created:  2013年08月23日 20时04分16秒
 * =====================================================================================
 */

#ifndef _SW_SLEEP_H
#define _SW_SLEEP_H

#include <asm/pal.h>
#include <asm/ptrace.h>
#define SOFTINF_SLEEP_MAGIC 0x0123456789ABCDEFUL

#ifdef CONFIG_HIBERNATION
struct vcpucb {
    uint64_t VC__FREG_256_0;
    uint64_t VC__FREG_256_1;
    uint64_t VC__FREG_256_2;
    uint64_t VC__FREG_256_3;  /* FREG_256 for save f0,it must be 256 byte align.Be care,don't add item before it. */
    uint64_t VC__VPTB ;
    uint64_t VC__PTBR ;
    uint64_t VC__PCBB ;
    uint64_t VC__KSP ;
    uint64_t VC__USP ;
    uint64_t VC__KGP ;
    uint64_t VC__ENT_ARITH ;
    uint64_t VC__ENT_IF ;
    uint64_t VC__ENT_INT ;
    uint64_t VC__ENT_MM ;
    uint64_t VC__ENT_SYS ;
    uint64_t VC__ENT_UNA ;
    uint64_t VC__STACK_PC ;
    uint64_t VC__NEW_A0 ;
    uint64_t VC__NEW_A1 ;
    uint64_t VC__NEW_A2 ;
    uint64_t VC__WHAMI ;
    uint64_t VC__PRBR ;
    uint64_t VC__VPCR ;
    uint64_t VC__UPCR ;

    uint64_t VC__VMEM_OFFSET;
    uint64_t VC__VMM_HCALL_ENTRY;
    uint64_t VC__VCPUID;
    uint64_t VC__HARD_CPUID;
    uint64_t VC__HARD_CGID;
    uint64_t VC__DOMAIN_ID;
    uint64_t VC__NODE_ID;
    uint64_t VC__VSP;
    uint64_t VC__VGP;
    uint64_t VC__VMM_ENT_INT;
    uint64_t VC__ENT_VERR;
    uint64_t VC__IER0;
    uint64_t VC__IER1;
    uint64_t VC__IER2;
    uint64_t VC__IER3;
    uint64_t VC__II_ER;
    uint64_t VC__CSR;
    uint64_t VC__WAKEUP_MAGIC;
    uint64_t VC__DEADLOOP_TYPE;
};
#endif

struct processor_state {
    struct pt_regs regs;
    struct switch_stack stack; 
#ifdef CONFIG_HIBERNATION
    struct pcb_struct pcb;
    struct vcpucb vcb;
#endif
};
extern inline void sw_64_enable_sleep_interrupt_self(void)
{
    sleepen();
}
extern inline void sw_64_enable_mt_interrupt_self(void)
{
    mtinten();
}
extern void send_sleep_interrupt(int vcpuid);
extern void send_wakeup_interrupt(int vcpuid);

extern void sw_64_suspend_deep_sleep(struct processor_state * state);
#endif /* _SW_SLEEP_H */
