/*
 * =====================================================================================
 *       Filename:  domctl.h
 *    Description:  
 *        Created:  2008年12月22日 11时36分32秒
 * =====================================================================================
 */

#ifndef  _SWVMM_INTERFACE_DOMCTL_H_
#define  _SWVMM_INTERFACE_DOMCTL_H_
#include <asm/swvmm/swvmm.h>


#define SWVMM_DOMCTL_createdomain       1
#define SWVMM_DOMCTL_rebuilddomain      2
#define SWVMM_DOMCTL_rebuildcurrent 	3
#define SWVMM_DOMCTL_max_vcpus 4
#define SWVMM_DOMCTL_sleepdomain 5
#define SWVMM_DOMCTL_sleep_currentdomain 6
#define SWVMM_DOMCTL_wakeup_currentdomain 7
#define SWVMM_DOMCTL_wakeup_domain 8
#define SWVMM_DOMCTL_reboot_domain 9
#define SWVMM_DOMCTL_hotreset_domain 10
#define SWVMM_DOMCTL_pause_domain 11
#define SWVMM_DOMCTL_max_mem 12
#define SWVMM_DOMCTL_unpause_domain 13
#define SWVMM_DOMCTL_migrate_domain 14
#define SWVMM_DOMCTL_resetslavecore 15
#define SWVMM_DOMCTL_sleepcore          16
#define SWVMM_DOMCTL_wakeupcore         17

#define DOMCTL_CREATDOMAIN_PIN_CGID_FLAG_BIT 0
#define DOMCTL_CREATDOMAIN_PIN_CGID_FLAG (1UL<<DOMCTL_CREATDOMAIN_PIN_CGID_FLAG_BIT)


struct swvmm_domctl_createdomain {
	/* IN parameters */
	unsigned long flags;
};
typedef struct swvmm_domctl_createdomain swvmm_domctl_createdomain_t;
DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_createdomain_t);

struct swvmm_domctl_max_vcpus {
	uint32_t max;
};
typedef struct swvmm_domctl_max_vcpus swvmm_domctl_max_vcpus_t;
DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_max_vcpus_t);

struct swvmm_domctl_max_mem {
	unsigned long max_mem_mb;
};
typedef struct swvmm_domctl_max_mem swvmm_domctl_max_mem_t;
DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_max_mem_t);

struct swvmm_domctl_hotreset {
	unsigned long mask;
	unsigned long hmcode_addr;
	unsigned long hmcode_size;
	unsigned long vmm1_addr;
	unsigned long vmm1_size;
	unsigned long vmm2_addr;
	unsigned long vmm2_size;
	unsigned long vmm3_addr;
	unsigned long vmm3_size;
	unsigned long kernel_addr;
	unsigned long kernel_size;
	unsigned long initrd_addr;
	unsigned long initrd_size;
};
typedef struct swvmm_domctl_hotreset swvmm_domctl_hotreset_t;

struct swvmm_domctl_resetslavecore {
        unsigned long reset_slavecore;
};
typedef struct swvmm_domctl_resetslavecore swvmm_domctl_resetslavecore_t;

DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_hotreset_t);


#define MIGRATE_INIT 1
#define MIGRATE_DONE 2
#define MIGRATE_SAVE_VCPU 3
#define MIGRATE_RESTORE_VCPU  4
#define MIGRATE_GET_TARGET 5
#define MIGRATE_RESUME_SLAVE 6 
#define MIGRATE_TRANSFER_MEM 7
#define MIGRATE_SUSPEND_HCA 8
#define MIGRATE_RESUME_HCA 9
#define MIGRATE_SAVE_TARGET 10

#define MIGRATE_ROLE_SRC 1
#define MIGRATE_ROLE_DES 0
struct swvmm_domctl_migrate {
	uint64_t cmd;
	uint64_t target_cpuid;
	uint64_t src_cpuid;
	uint64_t role;
	uint64_t migrate_cpu;        /** 迁移全片 = CG_BitMask， 否则 = 0 */
	uint64_t src_cgid;           /** 物理CGID，源和目的方都要设置，该设置只在 migrate_cpu = 0时生效 */
	uint64_t target_cgid;        /** 物理CGID，源和目的方都要设置，该设置只在 migrate_cpu = 0时生效 */
};
typedef struct swvmm_domctl_migrate swvmm_domctl_migrate_t;


struct swvmm_domctl_sleepcoremask {
        unsigned long sleep_mask;
};
typedef struct swvmm_domctl_sleepcoremask swvmm_domctl_sleepcoremask_t;
        
        
struct swvmm_domctl_wakeupcoremask {
        unsigned long wakeup_mask;
};      
typedef struct swvmm_domctl_wakeupcoremask swvmm_domctl_wakeupcoremask_t;

DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_migrate_t);

struct swvmm_domctl {
	uint64_t cmd;
	uint64_t interface_version; /* SWVMM_DOMCTL_INTERFACE_VERSION */
	uint64_t  domain_id;
	union {
		struct swvmm_domctl_createdomain      createdomain;
		struct swvmm_domctl_max_vcpus 	      max_vcpus;
		struct swvmm_domctl_max_mem 	      max_mem;
		struct swvmm_domctl_hotreset 	      hotreset;
		struct swvmm_domctl_migrate 	      migrate;	
		struct swvmm_domctl_resetslavecore    resetslavecore;
		struct swvmm_domctl_sleepcoremask     sleepcoremask;
                struct swvmm_domctl_wakeupcoremask    wakeupcoremask;
	} u;
};

typedef struct swvmm_domctl swvmm_domctl_t;
DEFINE_SWVMM_USER_HANDLE(swvmm_domctl_t);

extern int do_domctl(SWVMM_USER_HANDLE(swvmm_domctl_t) u_domctl);
#endif   /* ----- #ifndef _SWVMM_INTERFACE_DOMCTL_H_  ----- */
